"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class SupplementaryAnalysisResults(ProtocolElement):
    """
    This is the record for results of supplementary analysis
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "ContextualAnalysisSubstitutionsCounts",
        "GenomicRegionsOfHypermutation",
        "IndelAlleleFrequencyHistogramCounts",
        "IndelLengthHistogramCounts",
        "MutationalSignatureContribution",
        "SNValleleFrequencyHistogramCounts",
        "numberOfNonsynSomaticSnvsPerMb",
        "numberOfSomaticSnvsPerMb",
        "numberOfSomaticVariants",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_1_0_0 import metrics as metrics_1_0_0

        return {
            "org.gel.models.report.avro.SupplementaryAnalysisResults": metrics_1_0_0.SupplementaryAnalysisResults,
        }

    __slots__ = [
        "ContextualAnalysisSubstitutionsCounts",
        "GenomicRegionsOfHypermutation",
        "IndelAlleleFrequencyHistogramCounts",
        "IndelLengthHistogramCounts",
        "MutationalSignatureContribution",
        "SNValleleFrequencyHistogramCounts",
        "numberOfNonsynSomaticSnvsPerMb",
        "numberOfSomaticSnvsPerMb",
        "numberOfSomaticVariants",
    ]

    def __init__(
        self,
        ContextualAnalysisSubstitutionsCounts,
        GenomicRegionsOfHypermutation,
        IndelAlleleFrequencyHistogramCounts,
        IndelLengthHistogramCounts,
        MutationalSignatureContribution,
        SNValleleFrequencyHistogramCounts,
        numberOfNonsynSomaticSnvsPerMb,
        numberOfSomaticSnvsPerMb,
        numberOfSomaticVariants,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_0_0.SupplementaryAnalysisResults model.

        :param ContextualAnalysisSubstitutionsCounts:
        :type ContextualAnalysisSubstitutionsCounts: dict[str, int]
        :param GenomicRegionsOfHypermutation:
        :type GenomicRegionsOfHypermutation: list[str]
        :param IndelAlleleFrequencyHistogramCounts:
        :type IndelAlleleFrequencyHistogramCounts: dict[str, int]
        :param IndelLengthHistogramCounts:
        :type IndelLengthHistogramCounts: dict[str, int]
        :param MutationalSignatureContribution:
        :type MutationalSignatureContribution: dict[str, double]
        :param SNValleleFrequencyHistogramCounts:
        :type SNValleleFrequencyHistogramCounts: dict[str, int]
        :param numberOfNonsynSomaticSnvsPerMb:
        :type numberOfNonsynSomaticSnvsPerMb: double
        :param numberOfSomaticSnvsPerMb:
        :type numberOfSomaticSnvsPerMb: double
        :param numberOfSomaticVariants:
        :type numberOfSomaticVariants: int
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.0.0"
